// assembly variables
volatile unsigned char asmi; // chars for assembly
volatile unsigned char asmj; // chars for assembly
unsigned int i;

void
delay_us(unsigned long n)
{
    for (i = 0; i < n; ++i) {
//__asm
#asm
    ; 1us delay (4 cycles)
    movlw 0x02
    movwf _asmi
    iloop:
        decfsz _asmi,f
    goto iloop
#endasm
//__endasm;
    }
}

void
delay_ms(unsigned long n)
{
    for (i = 0; i < n; ++i) {
//__asm
#asm
    ; 1ms delay (54 * 74 = 3996 cycles)
    movlw 0x36
    movwf _asmi
    movlw 0x4a
    movwf _asmj
    iloop:
        movwf _asmj
    jloop:
        decfsz _asmj,f
    goto jloop
    decfsz _asmi,f
    goto iloop
#endasm
//__endasm;
    }
}

